package popupsample.editors;

import java.util.Iterator;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.ITreeSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.contexts.IContextService;
import org.eclipse.ui.part.DrillDownAdapter;
import org.eclipse.ui.part.EditorPart;

import popupsample.provider.NameSorter;
import popupsample.provider.ViewContentProvider;
import popupsample.provider.ViewLabelProvider;

public class SampleEditor extends EditorPart {
    private TreeViewer viewer;
    private DrillDownAdapter drillDownAdapter;
    private Action action1;
    private Action action2;
    private Action doubleClickAction;

    public SampleEditor() {
    }

    @Override
    public void doSave(IProgressMonitor monitor) {
    }

    @Override
    public void doSaveAs() {
    }

    @Override
    public void init(IEditorSite site, IEditorInput input) throws PartInitException {
        setSite(site);
        setInput(input);
    }

    @Override
    public boolean isDirty() {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean isSaveAsAllowed() {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public Object getAdapter(Class adapter) {

        return null;

        // return super.getAdapter(adapter);
    }

    @Override
    public void createPartControl(Composite parent) {
        viewer = new TreeViewer(parent, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
        drillDownAdapter = new DrillDownAdapter(viewer);
        viewer.setContentProvider(new ViewContentProvider(getSite()));
        viewer.setLabelProvider(new ViewLabelProvider());
        viewer.setSorter(new NameSorter());
        viewer.setInput(getEditorSite());

        // ZNVvoC_[̐ݒ
        getSite().setSelectionProvider(viewer);

        // ReLXgj[̐ݒ
        MenuManager menuMgr = new MenuManager("#PopupMenu");
        menuMgr.setRemoveAllWhenShown(true);
        menuMgr.addMenuListener(new IMenuListener() {
            public void menuAboutToShow(IMenuManager manager) {
                fillContextMenu(manager);
            }
        });
        Menu menu = menuMgr.createContextMenu(viewer.getControl());
        viewer.getControl().setMenu(menu);
        getEditorSite().registerContextMenu(menuMgr, viewer, false);// ReLXgj[O֌J
        // L[oCh̐ݒ
        IContextService contextService = (IContextService) getSite().getService(IContextService.class);
        contextService.activateContext("popupsample.context");

        makeActions();
    }

    private void fillContextMenu(IMenuManager manager) {
        manager.add(action1);
        // manager.add(action2);
        // manager.add(new Separator());
        // drillDownAdapter.addNavigationActions(manager);
        // Other plug-ins can contribute there actions here
        manager.add(new Separator(IWorkbenchActionConstants.MB_ADDITIONS));
    }

    private void makeActions() {
        action1 = new Action() {
            public void run() {
                showMessage("Action 1 executed");
            }
        };
    }

    private void showMessage(String message) {

        Object mapping = getSite().getAdapter(org.eclipse.core.resources.mapping.ResourceMapping.class);
        if (mapping != null) {
            MessageDialog.openInformation(viewer.getControl().getShell(), "Sample View", mapping.toString());
        }
        mapping = getAdapter(org.eclipse.core.resources.mapping.ResourceMapping.class);
        if (mapping != null) {
            MessageDialog.openInformation(viewer.getControl().getShell(), "Sample View", mapping.toString());
        }
        ISelection iSelection = viewer.getSelection();
        if (iSelection instanceof IStructuredSelection) {
            IStructuredSelection structuredSelection = (IStructuredSelection) iSelection;
            Iterator<Object> ite = structuredSelection.iterator();
            while (ite.hasNext()) {
                Object selection = ite.next();
                System.out.println(" selection : " + selection);
            }
        }
        if (iSelection instanceof ITreeSelection) {
            ITreeSelection treeSelection = (ITreeSelection) iSelection;

        }

        mapping = getEditorInput().getAdapter(org.eclipse.core.resources.mapping.ResourceMapping.class);

        if (mapping != null) {
            MessageDialog.openInformation(viewer.getControl().getShell(), "Sample View", mapping.toString());
        }

    }

    @Override
    public void setFocus() {
        viewer.getControl().setFocus();
    }

}
